#ifndef __S2ECORE_H_
#define __S2ECORE_H_

#include <stdio.h>
#include "misc.h"
#include "stm32f10x_rcc.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_usart.h"

#define USART2_DR_Address		((uint32_t)0x40004404)
#define USART3_DR_Address  		((uint32_t)0x40004804)

#define SERIAL_RX_PHERI
#define SERIAL_TX_PHERI

#define TIMER_IRQ_HANDLER		TIM2_IRQHandler
#define DMARECV_IRQ_HANDLER		DMA1_Channel3_IRQHandler
#define DMASEND_IRQ_HANDLER		DMA1_Channel7_IRQHandler
#define SERIAL_IRQ_HANDLER		USART3_IRQHandler

#define ETH_MAX_BUF_SIZE		1024
#define QUEUE_BUFFER_TX_SIZE	4*1024	//4k bytes
#define QUEUE_BUFFER_RX_SIZE	4*1024	//4k bytes
#define	QUEUE_MAX_SIZE			20		//20

#define ETH_MODE_TCPS			0
#define ETH_MODE_TCPC			1
#define ETH_MODE_MIXED			2
#define ETH_MODE_UDP			3

#define DEFAULT_SOCKET_NO		0

#define CMD_TIME_GAP			100

typedef struct _MQUEUE
{
	uint8_t * start;
	uint32_t size;
}mQueue;

void vTskS2ECore( void *pbParameters );
void vTskEthSend( void *pvParameters );
void vTskEthRecv( void *pvParameters );

void vS2EHardwareInit(void);
/*Interrupt handler*/
void TIMER_IRQ_HANDLER( void );//Time out interrupt handler
void DMARECV_IRQ_HANDLER( void );//DMA Buffer Full interrupt handler
void DMASEND_IRQ_HANDLER( void );//DMA Transmit done interrupt handler
void SERIAL_IRQ_HANDLER( void );//Uart recv interrupt handler

#endif
