/**************************************************************************//*****
 * @file     stdio.c
 * @brief    Implementation of newlib syscall
 ********************************************************************************/

#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "stm32f10x_usart.h"

#undef errno
extern int errno;
extern int  _end;

/*This function is used for handle heap option*/
__attribute__ ((used))
caddr_t _sbrk ( int incr )
{
    static unsigned char *heap = NULL;
    unsigned char *prev_heap;

    if (heap == NULL) {
        heap = (unsigned char *)&_end;
    }
    prev_heap = heap;

    heap += incr;

    return (caddr_t) prev_heap;
}

__attribute__ ((used))
int link(char *old, char *new)
{
    return -1;
}

__attribute__ ((used))
int _close(int file)
{
    return -1;
}

__attribute__ ((used))
int _fstat(int file, struct stat *st)
{
    st->st_mode = S_IFCHR;
    return 0;
}

__attribute__ ((used))
int _isatty(int file)
{
    return 1;
}

__attribute__ ((used))
int _lseek(int file, int ptr, int dir)
{
    return 0;
}

__attribute__((used))
int _write(int file,char* ptr,int len){
	int i = 0;
	(void)file;
	for(i = 0 ; i < len ; i++)
	{
		USART_SendData(USART1,*ptr++);
		while(USART_GetFlagStatus(USART1,USART_FLAG_TXE) == RESET);
	}
	return len;
}

__attribute__ ((used))
int _read(int file, char *ptr, int len)
{
     //user code example
     int i;
     int lenCnt = 0;
     (void)file;

     for(i = 0; i < len; i++)
     {
    	 while ((USART1->SR & USART_SR_RXNE) == 0){}
        // UART_GetChar is user's basic input function
    	 lenCnt++;
        *ptr = USART_ReceiveData(USART1);
        if(*ptr == 0x0d){
        	//*ptr = '\n';
        	break;
        }
        ptr++;
     }
    return lenCnt;
}

__attribute__ ((used))
void abort(void)
{
    /* Abort called */
    while(1);
}

/* --------------------------------- End Of File ------------------------------ */
